// -------------------------------------------
//                      PLC 
// -------------------------------------------


#ifndef PLC2_H
#define PLC2_H



#include <iostream>
#include "setval.h"

extern RegionGraph * __CurrentRG;

class PLC : public SetVal {
 private :
  int rien;

 public :
  PLC(int i=0) ; // 0 vide / 1 tout / 2 init  
  PLC(LnuTest * f) ;
  void Destroy() ;
  void Union(SetVal* sr);
  int Compacter() ; 
  void Intersection(SetVal * sr);
  void Print();
  void Add_Past(Ident_L *ls=0,int cforall=0);
  void Add_Future(Ident_L *ls=0);
  void Add_FermetureTemp(Ident_L *ls=0);
  void Forall(Ident_L *ls =0);
  void Rev_In(Ident c,Ident ca =0, int ia =0);
  int Est_vide();
  int Est_inclu(SetVal * sr);
  void Projection(Ident c,Ident ca =0, int ia =0);
  SetVal * Complement();
  SetVal * Copy() ;
  int Size();
  int Type() {return 1;} // 0 dbm et 1 ppl
};


#endif
