/* File: main.cc -- Francois -- Last modified on 15 Nov 2001
 * 	
 *      Main
 *
 */

#include <fstream.h>
#include <stdio.h>
#include <unistd.h>


#include "lnu.h"
#include "ta.h"
#include "env.h"
#include "acces.h"

extern void yyparse();
extern int yylinenumber;


#include "PLC2.h"


extern int RSconfig::NbVisitSucc;

int __POLYMEM=0;

int __CPLNU = 0;
int __CPSPEC = 0;
int __CPZONE = 0;
int __CPSR = 0;
int __CPCF = 0;
int __OPTIZONE = 0;
int __OPTICOMPACT = 0;
int __NOPTICOMPACT = 0;
int __OPTIEC = 0;
int __NOPTIEC = 0;
int __ZADDFUTUR =0;
int __ZADDPAST =0;
int __ZREVIN =0;
int __ZPROJ =0;
int __ZINTER =0;
int __ZFORAL =0;
int __ZESTINCL =0;
int __ZCOMPL =0;
int __ZCOMPLOPTI =0;
int __ZNORMAL =0;


int __FIXPOINT = 0; // vaut 1 en cours de calcul du point fixe 
                    // utilise pour le type de forme normale

int __MINFIXPOINT = 0; // 1 ssi on calcule [[-Spec]] dans Check (avec pppf)
int __NBFIXPOINT=-1;  // -1 : pas le limite !
int __HYBRID = 0;     //  a priori, on a des TA
int __CMAX  = 1000; //  est remis a` jour soit dans l'env (Cmax), soit 
                      // si TA, on lui affecte la cste max !
int __NOABSTRACT  = 0; // si 1 alors pas d'abrstraction apres Floyd - DBM
//int __INFTY = 1000000; // utiliser pour les DBM !


int __OVERAPPROX = 0;  // repere les sur-approx dans les calcul de Check
int __UNDERAPPROX = 0;
int __ABSTRACTION = 0; // est mis a` 1 si on a fait une abstraction
// ie si une borne sup a ete mise a` -2INFTY-1 ou une binf a 2INFTY+1

int __HACHAGE = 1;  // utilise pour le calcul  la vole.

int __DBMPLC = 0;  // 0 -> DBM  ----  1 -> Parma Lib. Constr. 

int SIMPLEE = 1;
int SIMPLTE = 1;
int SIMPLHZ = 1;
int SIMPLHZ2 = 1;
int SIMPLSPLIT = 0;
int SIMPLSPLITaux = 1;
int PTRACE = 0;
int VERBOSE = 1;
int SIMPLUNGVAR = 0;
char * LATEXOUTPUT = 0;
char * VCGOUTPUT = 0;
int BELL = 1;


int __NOUVEAULABEL=0;
int __NOUVELLESPEC=0;
int * __TABRESQUOT[2];
int __LASTQUOTIENT=0;  // utilise dans Constraint - 
                       // modifie dans specif.cc, Quotient

Env Envir;

class RegionGraph;
RegionGraph * __CurrentRG = (RegionGraph *) 0; // utilise pour PPL


int main()
{
RSconfig::NbVisitSucc = 0;
  //  yydebug = 1;
  //long gaspi=0;
__TABRESQUOT[0] = 0;
__TABRESQUOT[1] = 0;

 cout << "Hybrid and Compositional  Model Checking " << endl;
 cout << "http://www.lsv.ens-cachan.fr/~fl/" << endl;
 cout << "version 2.0 b - (DBM + control ) " << endl;
 cout << "% ";

  yyparse();

  Envir.Vide();

  /* Test :
  cout << "Add futur   : " << __ZADDFUTUR << endl;
  cout << "Rev_in      : " << __ZREVIN << endl;
  cout << "Projection  : " << __ZPROJ << endl;
  cout << "Intersecti  : " << __ZINTER << endl;
  cout << "For All     : " << __ZFORAL << endl;
  cout << "Est_inclu   : " << __ZESTINCL << endl;
  cout << "Complement  : " << __ZCOMPL << endl;
   cout << "Compl (opti): " << __ZCOMPLOPTI << endl;
   cout << "Normal      : " << __ZNORMAL << endl;

   cout << endl << "PLC creer - detruit = " << __POLYMEM << endl;
  */

}



