/* File: type.h -- Francois -- Last modified on 2 Feb 2001
 * 	
 *      type des objets de l'environnement
 *
 */



#ifndef TYPE_H
#define TYPE_H

#include "liste.h"

enum TYPEB {Void, Int, Flnu, Ta, Dec, Fsy, Spec, Undef, Star, String, CFlag, Table, System, Dbm, Setval, Lid}; 
// Star compte pour n'importe quel autre type de base...

class Ltype;
class type;
class Objet;
typedef Objet * PtObjet;
typedef Liste<PtObjet> LObjet;

class TYPEF {
  public :
    Ltype * larg;
    type  * val;
};


class type {
  private :
    int base;   // 0 ssi fct ou proc
    union {
      TYPEB valb;
      TYPEF valf;
    };
  public :

    type() {base =1; valb = Undef;}
  type(TYPEB t);
  type(Ltype * l,TYPEB t);
  type(Ltype * l,type * t);
  TYPEB Valb();
  TYPEF Valf();
  int Est_typeb() {return base;}
  void Print();
  void Destroy();
  
  int Egal(type *t);
  int Egal(Objet *t);
  int EstComp(type *t);  // 1 ssi t < this
  int EstComp(Objet *t); // 1 ssi t < this
};
		     

class Ltype {
  private :

    class Element {
    public:
     type * val;
     Element * suivant;
    };
  typedef Element * Ptr_Element;
  Ptr_Element debut;

  public :

  Ltype()
    {debut = 0;}

  Ltype(type * t)
    {debut = 0; Ajouter(t);}
  Ltype(TYPEB t)
    {debut = 0; Ajouter(new type(t));}

  void Print();
  void Ajouter(type * t);
  void Ajouterf(type * t);
  void Ajouter(TYPEB t);
  void Ajouterf(TYPEB t);
  int Est_vide();
  void Vide();
  void Destroy();
  int Egal(Ltype * l);
  int Egal(LObjet * l);
  int EstComp(Ltype * l);  // 1 ssi l < this
  int EstComp(LObjet * l); // 1 ssi l < this
};


#endif
